View Issue Details

IDProjectCategoryView StatusLast Update
0002837NoesisGUIUnity3Dpublic2024-01-31 14:42
Reporterpeanut Assigned Tojsantos  
PrioritynormalSeverityminorReproducibilityalways
Status resolvedResolutionreopened 
Product Version3.2 
Target Version3.2.3Fixed in Version3.2.3 
Summary0002837: VisualStateManager From MouseOver Raycast
DescriptionI am using VisualStateManager and I noticed that using:

<VisualTransition GeneratedDuration="0:0:2" From="MouseOver">

does not trigger if you go Off the button, with the ray from the controller, into empty space. It triggers eventually when you hover over any other UI element.
It works fine in Blend, triggers right away when you go Off the button, but in Unity it stays locked in hovered state until the ray hits another element.

Here is a recording of it from Unity: https://www.dropbox.com/scl/fi/ihxdb3nv2vldw2deix97x/Main-Windows-Mac-Linux-Unity-2022.3.10f1-_DX11_-2023-11-13-17-33-50.mp4?rlkey=vco4siz5dws5ny8l6s4wxbzjp&dl=0
TagsNo tags attached.
PlatformAny

Activities

jsantos

jsantos

2023-11-15 18:34

manager   ~0008942

Something like this should fix this issue (I didn't have time to try it, will do asap, just providing a quick workaround just in case this is critical)

Index: NoesisView.cs
===================================================================
--- NoesisView.cs	(revision 12945)
+++ NoesisView.cs	(working copy)
@@ -1190,8 +1190,8 @@
 
     private void UpdateActions(float t)
     {
-        int x = 0;
-        int y = 0;
+        int x = int.MaxValue;
+        int y = int.MaxValue;
         bool trackedPos = false;
 
         if (_trackedPositionAction?.activeControl != null && _trackedRotationAction?.activeControl != null)
@@ -1216,9 +1216,10 @@
                 x = (int)(worldPos.X / worldPos.W);
                 y = (int)(worldPos.Y / worldPos.W);
 
-                MouseMove(x, y);
                 trackedPos = true;
             }
+
+            MouseMove(x, y);
         }
 
         if (_trackedTriggerAction != null)

peanut

peanut

2023-11-15 20:34

reporter   ~0008943

Hey, tested, works like a charm, thanks so much!
peanut

peanut

2023-11-22 14:49

reporter   ~0008969

Hello, I noticed this fix alters how slider behaves if you click and drag, then go off UI element into empty space.
Before the fix if you went off UI while dragging the Thumb the value froze on current position.
After the fix the value of slider jumps to 0.
I don't think the new behavior is desired regarding the slider.

Issue History

Date Modified Username Field Change
2023-11-15 17:12 peanut New Issue
2023-11-15 17:17 jsantos Assigned To => jsantos
2023-11-15 17:17 jsantos Status new => assigned
2023-11-15 17:17 jsantos Target Version => 3.2.3
2023-11-15 18:34 jsantos Note Added: 0008942
2023-11-15 18:34 jsantos Status assigned => feedback
2023-11-15 20:34 peanut Note Added: 0008943
2023-11-15 20:34 peanut Status feedback => assigned
2023-11-16 00:42 jsantos Status assigned => resolved
2023-11-16 00:42 jsantos Resolution open => fixed
2023-11-16 00:42 jsantos Fixed in Version => 3.2.3
2023-11-22 14:49 peanut Status resolved => feedback
2023-11-22 14:49 peanut Resolution fixed => reopened
2023-11-22 14:49 peanut Note Added: 0008969
2024-01-22 11:40 jsantos Status feedback => assigned
2024-01-22 11:47 sfernandez Target Version 3.2.3 => 3.2.4
2024-01-22 11:47 jsantos Target Version 3.2.4 => 3.2.3
2024-01-31 14:42 jsantos Status assigned => resolved